import { Component } from '@angular/core';
import { FormControl, FormGroup, FormBuilder } from '@angular/forms';
import "rxjs/add/operator/distinctUntilChanged";
import { takeUntil, tap } from 'rxjs/operators';
import { Observable } from 'rxjs/Observable';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'app';
  form:FormGroup;
  constructor(private fb: FormBuilder){

    this.form = this.fb.group({
      name: ''
    });

    this.form.get('name').valueChanges.pipe(tap(res => {console.log(res)}))
      .distinctUntilChanged()
      .subscribe();
  }
}